image: docker:latest

services:
  - docker:dind

stages:
  - test-python
  - build
  - test
  - release
  - deploy


variables:
  CI_DOCKER_IMAGE:  default-route-openshift-image-registry.apps.sandbox.x8i5.p1.openshiftapps.com/osmietianee-dev/${CI_PROJECT_ID}:${CI_COMMIT_SHA}
  CI_DOCKER_BRANCH: default-route-openshift-image-registry.apps.sandbox.x8i5.p1.openshiftapps.com/osmietianee-dev/${CI_PROJECT_ID}:${CI_COMMIT_REF_NAME}
  CI_DOCKER_LATEST: default-route-openshift-image-registry.apps.sandbox.x8i5.p1.openshiftapps.com/osmietianee-dev/${CI_PROJECT_ID}:latest

Test Python:
  image: python:latest
  stage: test-python
  variables:
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
  cache:
    paths:
      - .cache/pip
      - venv/    
  before_script: 
    - python --version
    - pip install virtualenv
    - virtualenv venv
    - source venv/bin/activate
    - pip install -r requirements.txt
    - pip install pytest pytest-cov pytest-html pytest-sugar pytest-json-report
  script:
    - pytest -v --cov --html=report.html

Docker Build:
  stage: build
  before_script:
    - docker login -u "$CI_REGISTRY_USER" $CI_REGISTRY -p "$CI_REGISTRY_PASSWORD"
  script:
    - docker build --pull -t ${CI_DOCKER_IMAGE} .
    - docker push ${CI_DOCKER_IMAGE}

Docker Test:
  stage: test
  before_script:
    - docker login -u "$CI_REGISTRY_USER" $CI_REGISTRY -p "$CI_REGISTRY_PASSWORD"
  script:
    - docker pull ${CI_DOCKER_IMAGE}
    - docker tag ${CI_DOCKER_IMAGE} ${CI_DOCKER_BRANCH}
    - docker run ${CI_DOCKER_IMAGE} /path/to/test.sh

Release Branch:
  stage: release
  before_script:
    - docker login -u "$CI_REGISTRY_USER" $CI_REGISTRY -p "$CI_REGISTRY_PASSWORD"
  script:
    - docker pull ${CI_DOCKER_IMAGE}
    - docker tag ${CI_DOCKER_IMAGE} ${CI_DOCKER_BRANCH}
    - docker push ${CI_DOCKER_BRANCH}
  only:
    - branches
  except:
    - master

Release Latest:
   stage: release
   before_script:
     - docker login -u "$CI_REGISTRY_USER" $CI_REGISTRY -p "$CI_REGISTRY_PASSWORD"
   script:
     - docker pull ${CI_DOCKER_IMAGE}
     - docker tag ${CI_DOCKER_IMAGE} ${CI_DOCKER_LATEST}
     - docker push ${CI_DOCKER_LATEST}
   only:
     - master

.deploy: &deploy
  image: openshift/origin-cli
  before_script:
    - oc login https://$OPENSHIFT_IP:$OPENSHIFT_PORT --token=$OPENSHIFT_TOKEN --insecure-skip-tls-verify
    - oc project $CI_PROJECT_NAME
  script:
    - oc get services $APP 2> /dev/null || oc new-app blockchainapi-git:latest --name=$APP
    - oc start-build $APP --from-dir=blockchainapi-git:latest --follow || sleep 3s
    - oc get routes $APP 2> /dev/null || oc expose service $APP --hostname=$APP_HOST

Deploy to Openshift:
  <<: *deploy
  stage: deploy
  tags:
    - docker
  variables:
    APP: $CI_PROJECT_ID
    APP_HOST: $CI_PROJECT_NAME-$CI_PROJECT_ID.$OPENSHIFT_DOMAIN
  environment:
    name: develop
    url: http://$CI_PROJECT_NAME-$CI_PROJECT_ID.$OPENSHIFT_DOMAIN